﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using C1.Win.Chart;
using C1.Win.C1Chart;
using FlexChartVsC1Chart.Models;

namespace FlexChartVsC1Chart.Features
{
    public partial class ChartTypes : UserControl
    {
        FlexChart flexChart;
        C1Chart c1Chart;
        public ChartTypes()
        {
            InitializeComponent();
            baseFeature.UpdateChartType(FlexChartMode.Chart);
            flexChart = baseFeature.flexChart;
            c1Chart = baseFeature.c1Chart;
            SetupFlex();
            SetUpC1();
            SetUpDisplayCode();
        }


        private void SetupFlex()
        {
            flexChart.DataSource = DataSource.NumericData;
            flexChart.BindingX = "XValue";
            flexChart.Series.Clear();
            flexChart.Series.Add(new Series { Binding = "YValue", Name = "Sales" });
            flexChart.ChartType = C1.Chart.ChartType.Area;
            flexChart.Legend.Position = C1.Chart.Position.Bottom;


        }

        private void SetUpC1()
        {

            c1Chart.DataSource = DataSource.NumericData;
            c1Chart.ChartGroups[0].ChartData.SeriesList.Clear();

            var salesSeries = c1Chart.ChartGroups[0].ChartData.SeriesList.AddNewSeries();
            salesSeries.X.DataField = "XValue";
            salesSeries.Y.DataField = "YValue";
            salesSeries.Label = "Sales";
            c1Chart.ChartGroups[0].ChartType = Chart2DTypeEnum.Area;
            c1Chart.Legend.Visible = true;
            c1Chart.Legend.Compass = CompassEnum.South;

        }

        private void SetUpDisplayCode()
        {
            baseFeature.tbCodeFlex.Text = @"
flexChart.ChartType = C1.Chart.ChartType.Area;";
            baseFeature.tbCodeC1.Text = @"
c1Chart.ChartGroups[0].ChartType = Chart2DTypeEnum.Area;";
        }
    }
}
