﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using C1.Win.Chart;
using C1.Win.C1Chart;
using FlexChartVsC1Chart.Models;

namespace FlexChartVsC1Chart.Features
{
    public partial class FinancialCharts : UserControl
    {
        FlexChart flexChart;
        C1Chart c1Chart;
        public FinancialCharts()
        {
            InitializeComponent();
            baseFeature.UpdateChartType(FlexChartMode.Chart);
            flexChart = baseFeature.flexChart;
            c1Chart = baseFeature.c1Chart;
            SetupFlex();
            SetUpC1();
            SetUpDisplayCode();
        }

        private void SetupFlex()
        {
            flexChart.DataSource = DataSource.FinancialChartData;
            flexChart.BindingX = "Date";

            flexChart.Series.Clear();
            flexChart.Series.Add(new Series { Binding = "High,Low,Open,Close", Name = "HLOC" });
            flexChart.ChartType = C1.Chart.ChartType.HighLowOpenClose;

            flexChart.Legend.Position = C1.Chart.Position.Bottom;
        }

        private void SetUpC1()
        {
            c1Chart.DataSource = DataSource.FinancialChartData;
            c1Chart.ChartGroups[0].ChartData.SeriesList.Clear();

            var financialSeries = c1Chart.ChartGroups[0].ChartData.SeriesList.AddNewSeries();
            financialSeries.X.DataField = "Date";
            financialSeries.Y.DataField = "High";
            financialSeries.Y1.DataField = "Low";
            financialSeries.Y2.DataField = "Open";
            financialSeries.Y3.DataField = "Close";
            financialSeries.Label = "HLOC";

            c1Chart.ChartGroups[0].ChartType = Chart2DTypeEnum.HiLoOpenClose;
            c1Chart.Legend.Visible = true;
            c1Chart.Legend.Compass = CompassEnum.South;

        }

        private void SetUpDisplayCode()
        {
            baseFeature.tbCodeFlex.Text = @"
flexChart.Series.Add(new Series { Binding = ""High,Low,Open,Close"", Name = ""HLOC"" });
flexChart.ChartType = C1.Chart.ChartType.HighLowOpenClose;";

            baseFeature.tbCodeC1.Text = @"
var financialSeries = c1Chart.ChartGroups[0].ChartData.SeriesList.AddNewSeries();
financialSeries.X.DataField = ""Date"";
financialSeries.Y.DataField = ""High"";
financialSeries.Y1.DataField = ""Low"";
financialSeries.Y2.DataField = ""Open"";
financialSeries.Y3.DataField = ""Close"";
financialSeries.Label = ""HLOC"";
c1Chart.ChartGroups[0].ChartType = Chart2DTypeEnum.HiLoOpenClose;";
        }
    }
}
