﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

using C1.Win.Chart;
using C1.Win.C1Chart;
using FlexChartVsC1Chart.Models;

namespace FlexChartVsC1Chart.Features
{
    public partial class PieCharts : UserControl
    {
        FlexPie flexPie;
        C1Chart c1Chart;
        public PieCharts()
        {
            InitializeComponent();
            baseFeature.UpdateChartType(FlexChartMode.Pie);
            flexPie = baseFeature.flexPie;
            c1Chart = baseFeature.c1Chart;
            SetupFlex();
            SetUpC1();
            SetUpDisplayCode();
        }


        private void SetupFlex()
        {
            flexPie.DataSource = DataSource.CategoricalData;
            flexPie.BindingName = "Name";
            flexPie.Binding = "Sales";
            flexPie.DataLabel.Content = "{y}";
            flexPie.DataLabel.Position = C1.Chart.PieLabelPosition.Outside;
            flexPie.Legend.Position = C1.Chart.Position.Bottom;
        }

        private void SetUpC1()
        {

            var data = DataSource.CategoricalData;
            c1Chart.ChartGroups[0].ChartType = Chart2DTypeEnum.Pie;
            
            c1Chart.ChartGroups[0].Pie.Clockwise = true;
            c1Chart.ChartGroups[0].Pie.Start = 180;

            c1Chart.ChartGroups[0].ChartData.SeriesList.Clear();
            foreach (var item in data)
            {
                var pieSeries = c1Chart.ChartGroups[0].ChartData.SeriesList.AddNewSeries();
                pieSeries.PointData.Length = 1;
                pieSeries.Y[0] = item.Sales;
                pieSeries.Label = item.Name;

                C1.Win.C1Chart.DataLabel dlab = pieSeries.DataLabel;
                dlab.Compass = LabelCompassEnum.Orthogonal;
                dlab.Text = "{#YVAL}";
                dlab.Visible = true;
            }
            c1Chart.Legend.Visible = true;
            c1Chart.Legend.Compass = CompassEnum.South;
        }

        private void SetUpDisplayCode()
        {
            baseFeature.tbCodeFlex.Text = @"
flexPie.DataSource = DataSource.CategoricalData;
flexPie.BindingName = ""Name"";
flexPie.Binding = ""Sales"";
flexPie.DataLabel.Content = ""{y}"";
flexPie.DataLabel.Position = C1.Chart.PieLabelPosition.Outside;";

            baseFeature.tbCodeC1.Text = @"
var data = DataSource.CategoricalData;
c1Chart.ChartGroups[0].ChartType = Chart2DTypeEnum.Pie;
            
c1Chart.ChartGroups[0].ChartData.SeriesList.Clear();
foreach (var item in data)
{
    var pieSeries = c1Chart.ChartGroups[0].ChartData.SeriesList.AddNewSeries();
    pieSeries.PointData.Length = 1;
    pieSeries.Y[0] = item.Sales;
    pieSeries.Label = item.Name;

    C1.Win.C1Chart.DataLabel dlab = pieSeries.DataLabel;
    dlab.Compass = LabelCompassEnum.Orthogonal;
    dlab.Text = ""{#YVAL}"";
    dlab.Visible = true;
}";
        }
    }
}
